% This program generates a set of Strawberry Data which is stores in the
% matrix 'Data'

Data=[];
beta0=input('Enter the parameters [alpha beta gamma], ie [9 0 -3] ');       
beta0=beta0';
sigmasq=input('Enter sigmasq, ie 0.6 ');    
N=input('Enter the number of inflorescences ie 100 ');

% Loop through each inflorescence
for i=0:N-1
   y=1;
   r=2;
   m=1;

   % Random Inflorescence Effect
   b=randn(1,1)*sqrt(sigmasq);

   % Loop through each rank until there are no strawberry flowers at
   % a rank 
   while y~=0
      neta0=[1 m r]*beta0+b;
      pi0=1./(1+exp(-neta0));
      M=2*m;
      temp=rand;

      % Defining the probability distribution
      P=zeros(1,2*m+1);
      for Y=0:2*m
          const=factorial(M)/(factorial(Y)*factorial(M-Y)); 
          P(Y+1)=const*pi0^Y*(1-pi0)^(M-Y);
      end

      % Assigning the value of y
      test=P(1); 
      y=0;   
      while temp>test
         y=y+1;
         test=test+P(y+1);
      end   

      Data=[Data ; y m r zeros(1,i) 1 zeros(1, N-i-1)];
      r=r+1;
      m=y;
   end
end
